{-

Verwendung des Parsec-Parser-Generators

-------------------------------------------------------

Vortrag: Monadische Parser
Syntax-Analyse mit Haskell
(Funktionale Programmierung WS 08/09)

Mathias Mierswa (winf2920) und Thomas Stuht (inf6937)

8. Januar 2009

-}

module ParsecUse where

import Text.ParserCombinators.Parsec

identifier :: Parser String
identifier =     string "Mathias"
             <|> string "Thomas"

doParse :: Show a => Parser a -> String -> IO ()
doParse p xs = case (parse p "" xs) of
     Left err -> print err
     Right xs -> print xs
     
p1 = doParse identifier "Mathias"
p1b = doParse identifier "Ernie"

identifier' :: Parser String
identifier' =    string "Mathias"
             <|> string "Thomas"
             <?> "Name eines Vortragenden"
             
p2 = doParse identifier' "Ernie"

nesting :: Parser Int
nesting = do {char '('
             ; n <- nesting
             ; char ')'
             ; m <- nesting
             ; return (max (n+1) m)
             }
          <|> return 0
          
p3 = doParse nesting "(()()(()()))"

day =     string "Montag"
      <|> string "Dienstag"
      <|> string "Mittwoch"
      <|> string "Donnerstag"
      <|> string "Freitag"
      <|> string "Samstag"
      <|> string "Sonntag"
      
p4 = doParse day "Donnerstag"

day' =     try (string "Montag")
       <|> try (string "Dienstag")
       <|> try (string "Mittwoch")
       <|> try (string "Donnerstag")
       <|> try (string "Freitag")
       <|> try (string "Samstag")
       <|> string "Sonntag"
       
p5 = doParse day' "Donnerstag"